'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _iabVastModel = require('iab-vast-model');

var _click = require('./click');

var _click2 = _interopRequireDefault(_click);

var _resource = require('./resource');

var _resource2 = _interopRequireDefault(_resource);

var _mapTrackingEvents = require('../util/map-tracking-events');

var _mapTrackingEvents2 = _interopRequireDefault(_mapTrackingEvents);

var _isNonEmptyArray = require('../util/is-non-empty-array');

var _isNonEmptyArray2 = _interopRequireDefault(_isNonEmptyArray);

var _hasValue = require('../util/has-value');

var _hasValue2 = _interopRequireDefault(_hasValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function ($companion) {
  var companion = new _iabVastModel.Companion();
  companion.id = $companion.id;
  companion.width = $companion.width;
  companion.height = $companion.height;
  companion.assetWidth = $companion.assetWidth;
  companion.assetHeight = $companion.assetHeight;
  companion.expandedWidth = $companion.expandedWidth;
  companion.expandedHeight = $companion.expandedHeight;
  companion.apiFramework = $companion.apiFramework;
  companion.adSlotID = $companion.adSlotID;
  companion.pxratio = $companion.pxratio;
  companion.resource = (0, _resource2.default)($companion);
  if ($companion.adParameters != null && (0, _hasValue2.default)($companion.adParameters)) {
    companion.adParameters = $companion.adParameters._value;
  }
  if ($companion.altText != null && (0, _hasValue2.default)($companion.altText._value)) {
    companion.altText = $companion.altText._value;
  }
  if ($companion.companionClickThrough != null && (0, _hasValue2.default)($companion.companionClickThrough)) {
    companion.clickThrough = (0, _click2.default)($companion.companionClickThrough);
  }
  if ($companion.companionClickTracking != null) {
    var _companion$clickTrack;

    (_companion$clickTrack = companion.clickTrackings).push.apply(_companion$clickTrack, _toConsumableArray($companion.companionClickTracking.filter(_hasValue2.default).map(_click2.default)));
  }
  if ($companion.trackingEvents != null && (0, _isNonEmptyArray2.default)($companion.trackingEvents.tracking)) {
    companion.trackingEvents = new _iabVastModel.TrackingEvents();
    (0, _mapTrackingEvents2.default)($companion.trackingEvents, companion.trackingEvents);
  }
  return companion;
};