'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _iabVastModel = require('iab-vast-model');

var _parseTime = require('../util/parse-time');

var _parseTime2 = _interopRequireDefault(_parseTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (offsetStr, options, err) {
  var lastChar = offsetStr.charAt(offsetStr.length - 1);
  if (lastChar === '%') {
    var offset = new _iabVastModel.RelativeTimeOffset();
    offset.value = parseFloat(offsetStr.substr(0, offsetStr.length - 1));
    return offset;
  } else {
    var _offset = new _iabVastModel.AbsoluteTimeOffset();
    try {
      _offset.value = (0, _parseTime2.default)(offsetStr);
    } catch (err) {
      options.errorHandler(err);
    }
    return _offset;
  }
};