'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _iabVastModel = require('iab-vast-model');

var _javascriptResource = require('./javascript-resource');

var _javascriptResource2 = _interopRequireDefault(_javascriptResource);

var _flashResource = require('./flash-resource');

var _flashResource2 = _interopRequireDefault(_flashResource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function ($verification) {
  var verification = new _iabVastModel.Verification();
  verification.vendor = $verification.vendor;
  if ($verification.javaScriptResource != null) {
    var _verification$javaScr;

    (_verification$javaScr = verification.javaScriptResources).push.apply(_verification$javaScr, _toConsumableArray($verification.javaScriptResource.map(_javascriptResource2.default)));
  }
  if ($verification.flashResource != null) {
    var _verification$flashRe;

    (_verification$flashRe = verification.flashResources).push.apply(_verification$flashRe, _toConsumableArray($verification.flashResource.map(_flashResource2.default)));
  }
  if ($verification.viewableImpression != null) {
    verification.viewableImpression = $verification.viewableImpression._value;
  }
  // XXX Proposed properties subject to change
  if ($verification.verificationParameters != null) {
    verification.parameters = $verification.verificationParameters._value;
  }
  return verification;
};