'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _unmarshaler = require('./xml/unmarshaler');

var _unmarshaler2 = _interopRequireDefault(_unmarshaler);

var _schema = require('./vast/schema');

var _schema2 = _interopRequireDefault(_schema);

var _vast = require('./factory/vast');

var _vast2 = _interopRequireDefault(_vast);

var _strict = require('./errors/strict');

var _strict2 = _interopRequireDefault(_strict);

var _loose = require('./errors/loose');

var _loose2 = _interopRequireDefault(_loose);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_OPTIONS = {
  strict: false,
  noSingleAdPods: false
};

var toElement = function toElement(xml, options) {
  if (typeof xml === 'string') {
    var domParser = options.domParser || new DOMParser();
    xml = domParser.parseFromString(xml, 'text/xml');
  }
  if (xml.documentElement != null) {
    xml = xml.documentElement;
  }
  return xml;
};

exports.default = function (xml) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  options = Object.assign({}, DEFAULT_OPTIONS, options);
  options.errorHandler = options.strict ? _strict2.default : _loose2.default;
  var elem = toElement(xml, options);
  var unmarshaler = new _unmarshaler2.default(_schema2.default);
  var root = unmarshaler.unmarshal(elem);
  return (0, _vast2.default)(root, options);
};